diff --git a/src/zabbix_server/vmware/vmware.c b/src/zabbix_server/vmware/vmware.c
index 43dd9835e99..3379b506ac1 100644
--- a/src/zabbix_server/vmware/vmware.c
+++ b/src/zabbix_server/vmware/vmware.c
@@ -7635,16 +8359,17 @@ static void	vmware_service_cq_prop_value(const char *fn_parent, xmlDoc *xdoc, zb
  * Purpose: load vmware object property info from VC                          *
  *                                                                            *
  * Parameters: easyhandle - [IN] the CURL handle                              *
+ *             collector  - [IN] the name of vmware property collector        *
  *             cq_values  - [IN/OUT] the vector with custom query entries     *
  *                                     and responses                          *
  *                                                                            *
  ******************************************************************************/
-static void	vmware_service_props_load(CURL *easyhandle, zbx_vector_cq_value_t *cq_values)
+static void	vmware_service_props_load(CURL *easyhandle, const char *collector, zbx_vector_cq_value_t *cq_values)
 {
 #	define ZBX_POST_OBJ_PROP									\
 		ZBX_POST_VSPHERE_HEADER									\
 		"<ns0:RetrievePropertiesEx>"								\
-			"<ns0:_this type=\"PropertyCollector\">propertyCollector</ns0:_this>"		\
+			"<ns0:_this type=\"PropertyCollector\">%s</ns0:_this>"		\
 			"<ns0:specSet>"									\
 				"<ns0:propSet>"								\
 					"<ns0:type>%s</ns0:type>"					\
@@ -7659,22 +8384,26 @@ static void	vmware_service_props_load(CURL *easyhandle, zbx_vector_cq_value_t *c
 		"</ns0:RetrievePropertiesEx>"								\
 		ZBX_POST_VSPHERE_FOOTER
 
-	int	i, total = 0, count = 0;
-	xmlDoc	*doc = NULL;
+	int			i, total = 0, count = 0;
+	xmlDoc			*doc = NULL;
+	zbx_vector_cq_value_t	cq_resp;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() props total:%d", __func__, cq_values->values_num);
 
+	zbx_vector_cq_value_create(&cq_resp);
+	zbx_vector_cq_value_append(&cq_resp, NULL);
+
 	for (i = 0; i < cq_values->values_num; i++)
 	{
 		char			*error = NULL, tmp[MAX_STRING_LEN];
-		zbx_vmware_cq_value_t	*cqv = &cq_values->values[i];
+		zbx_vmware_cq_value_t	*cqv = cq_values->values[i];
 
 		if (0 == (cqv->instance->state & ZBX_VMWARE_CQ_SEPARATE))
 			continue;
 
 		zbx_xml_free_doc(doc);
-		zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_OBJ_PROP, cqv->instance->soap_type, cqv->instance->key,
-				cqv->instance->soap_type, cqv->instance->id);
+		zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_OBJ_PROP, collector, cqv->instance->soap_type,
+				cqv->instance->key, cqv->instance->soap_type, cqv->instance->id);
 		total++;
 
 		if (SUCCEED != zbx_soap_post(__func__, easyhandle, tmp, &doc, NULL, &error))
@@ -7685,12 +8414,14 @@ static void	vmware_service_props_load(CURL *easyhandle, zbx_vector_cq_value_t *c
 			continue;
 		}
 
-		vmware_service_cq_prop_value(__func__, doc, cqv);
+		cq_resp.values[0] = cqv;
+		vmware_service_cq_prop_value(__func__, doc, &cq_resp);
 		count++;
 	}
 
 	zbx_xml_free_doc(doc);
 
+	zbx_vector_cq_value_destroy(&cq_resp);
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s() count: %d / %d", __func__, count, total);
 
 #	undef ZBX_POST_OBJ_PROP
@@ -7702,37 +8433,81 @@ static void	vmware_service_props_load(CURL *easyhandle, zbx_vector_cq_value_t *c
  *                                                                            *
  * Parameters: cq_values - [IN] the vector with custom query entries          *
  *             soap_type - [IN] soap type of hv, vm etc                       *
- *             clusterid - [IN] cluster id                                    *
- *             bsz       - [IN] buffer size                                   *
- *             buff      - [IN/OUT] - buffer for soap query                   *
- *             cq_prop   - [OUT] - custom query entry                         *
+ *             obj_id    - [IN] vmware instance id (hv, vm etc)               *
+ *             cqvs      - [OUT] - custom query entry                         *
  *                                                                            *
  * Return value: pointer to string with soap sub query                        *
  *                                                                            *
  ******************************************************************************/
 static char	*vmware_cq_prop_soap_request(const zbx_vector_cq_value_t *cq_values, const char *soap_type,
-		const char *clusterid, const size_t bsz, char *buff, zbx_vmware_cq_value_t **cq_prop)
+		const char *obj_id, zbx_vector_cq_value_t *cqvs)
 {
-	int			i;
-	zbx_vmware_cust_query_t	instance = {.soap_type = (char *)soap_type, .id = (char *)clusterid};
-	zbx_vmware_cq_value_t	*cq, cmp = {.instance = &instance};
-
-	*buff = '\0';
-	*cq_prop = NULL;
+	int	i;
+	char	*buff = zbx_strdup(NULL, "");
 
-	if (FAIL == (i = zbx_vector_cq_value_bsearch(cq_values, cmp, vmware_cq_instance_id_compare)))
-		return buff;
+	for (i = 0; i < cq_values->values_num; i++)
+	{
+		zbx_vmware_cq_value_t	*cq = cq_values->values[i];
+		char			tmp[MAX_STRING_LEN / 4];
 
-	cq = &cq_values->values[i];
+		if (0 != cqvs->values_num && 0 != strcmp(cq->instance->id, obj_id))
+			break;
 
-	if (0 != (cq->instance->state & ZBX_VMWARE_CQ_SEPARATE))
-		return buff;
+		if (0 != (cq->instance->state & ZBX_VMWARE_CQ_SEPARATE) || 0 != strcmp(cq->instance->id, obj_id) ||
+				0 != strcmp(cq->instance->soap_type, soap_type))
+		{
+			continue;
+		}
 
-	zbx_snprintf(buff, bsz, "<ns0:pathSet>%s</ns0:pathSet>", cq->instance->key);
-	*cq_prop = cq;
+		zbx_snprintf(tmp, sizeof(tmp), "<ns0:pathSet>%s</ns0:pathSet>", cq->instance->key);
+		buff = zbx_strdcat(buff, tmp);
+		zbx_vector_cq_value_append(cqvs, cq);
+	}
 
 	return buff;
 }
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: set CURL headers for soap request                                 *
+ *                                                                            *
+ * Parameters: easyhandle - [IN] prepared cURL connection handle              *
+ *             vc_version - [IN] major version of vc                          *
+ *             headers    - [IN/OUT] the CURL headers                         *
+ *             error      - [OUT] the error message in the case of failure    *
+ *                                                                            *
+ * Return value: SUCCEED - the headers were set successfully                  *
+ *               FAIL    - otherwise                                          *
+ *                                                                            *
+ ******************************************************************************/
+static int	vmware_curl_set_header(CURL *easyhandle, int vc_version, struct curl_slist **headers, char **error)
+{
+	char		soapver[MAX_STRING_LEN / 32];
+	CURLoption	opt;
+	CURLcode	err;
+
+	if (0 != vc_version && 6 > vc_version)
+		return SUCCEED;
+	else if (6 > vc_version)
+		zbx_strlcpy(soapver, ZBX_XML_HEADER1_V4, sizeof(soapver));
+	else
+		zbx_strlcpy(soapver, ZBX_XML_HEADER1_V6, sizeof(soapver));
+
+	curl_slist_free_all(*headers);
+	*headers = NULL;
+	*headers = curl_slist_append(*headers, soapver);
+	*headers = curl_slist_append(*headers, ZBX_XML_HEADER2);
+	*headers = curl_slist_append(*headers, ZBX_XML_HEADER3);
+
+	if (CURLE_OK != (err = curl_easy_setopt(easyhandle, opt = CURLOPT_HTTPHEADER, *headers)))
+	{
+		*error = zbx_dsprintf(*error, "Cannot set cURL option %d: %s.", (int)opt, curl_easy_strerror(err));
+		return FAIL;
+	}
+
+	return SUCCEED;
+}
+
 /******************************************************************************
  *                                                                            *
  * Purpose: updates object with a new data from vmware service                *
@@ -7743,8 +8518,6 @@ static char	*vmware_cq_prop_soap_request(const zbx_vector_cq_value_t *cq_values,
 int	zbx_vmware_service_update(zbx_vmware_service_t *service)
 {
 	CURL			*easyhandle = NULL;
-	CURLoption		opt;
-	CURLcode		err;
 	struct curl_slist	*headers = NULL;
 	zbx_vmware_data_t	*data;
 	zbx_vector_str_t	hvs, dss;
@@ -7755,7 +8528,7 @@ int	zbx_vmware_service_update(zbx_vmware_service_t *service)
 	ZBX_HTTPPAGE		page;	/* 347K/87K */
 	unsigned char		evt_pause = 0, evt_skip_old;
 	zbx_uint64_t		evt_last_key, events_sz = 0;
-	char			msg[MAX_STRING_LEN / 8], soapver[MAX_STRING_LEN / 32];
+	char			msg[MAX_STRING_LEN / 8];
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() '%s'@'%s'", __func__, service->username, service->url);
 
@@ -7789,11 +8562,6 @@ int	zbx_vmware_service_update(zbx_vmware_service_t *service)
 
 	zbx_vector_cq_value_sort(&prop_query_values, vmware_cq_instance_id_compare);
 
-	if (6 > service->major_version)
-		zbx_strlcpy(soapver, ZBX_XML_HEADER1_V4, sizeof(soapver));
-	else
-		zbx_strlcpy(soapver, ZBX_XML_HEADER1_V6, sizeof(soapver));
-
 	if (NULL == (easyhandle = curl_easy_init()))
 	{
 		zabbix_log(LOG_LEVEL_WARNING, "Cannot initialize cURL library");
@@ -7802,15 +8570,9 @@ int	zbx_vmware_service_update(zbx_vmware_service_t *service)
 
 	page.alloc = ZBX_INIT_UPD_XML_SIZE;
 	page.data = (char *)zbx_malloc(NULL, page.alloc);
-	headers = curl_slist_append(headers, soapver);
-	headers = curl_slist_append(headers, ZBX_XML_HEADER2);
-	headers = curl_slist_append(headers, ZBX_XML_HEADER3);
 
-	if (CURLE_OK != (err = curl_easy_setopt(easyhandle, opt = CURLOPT_HTTPHEADER, headers)))
-	{
-		zabbix_log(LOG_LEVEL_WARNING, "Cannot set cURL option %d: %s.", (int)opt, curl_easy_strerror(err));
+	if (SUCCEED != vmware_curl_set_header(easyhandle, service->major_version, &headers, &data->error))
 		goto clean;
-	}
 
 	if (SUCCEED != vmware_service_authenticate(service, easyhandle, &page, &data->error))
 		goto clean;
@@ -7818,6 +8580,10 @@ int	zbx_vmware_service_update(zbx_vmware_service_t *service)
 	if (SUCCEED != vmware_service_initialize(service, easyhandle, &data->error))
 		goto clean;
 
+	/* update headers after VC version detection */
+	if (SUCCEED != vmware_curl_set_header(easyhandle, service->major_version, &headers, &data->error))
+		goto clean;
+
 	if (NULL != service->data && 0 != service->data->events.values_num && 0 == evt_skip_old &&
 			((const zbx_vmware_event_t *)service->data->events.values[0])->key > evt_last_key)
 	{
@@ -7830,13 +8596,6 @@ int	zbx_vmware_service_update(zbx_vmware_service_t *service)
 		goto clean;
 	}
 
-	if (ZBX_VMWARE_TYPE_VCENTER == service->type &&
-			SUCCEED != vmware_service_get_clusters_and_resourcepools(service, easyhandle,
-			&prop_query_values, &data->clusters, &data->resourcepools, &alarms_data, &data->error))
-	{
-		goto clean;
-	}
-
 	zbx_vector_vmware_datastore_reserve(&data->datastores, (size_t)(dss.values_num + data->datastores.values_alloc));
 
 	for (i = 0; i < dss.values_num; i++)
@@ -7852,6 +8611,13 @@ int	zbx_vmware_service_update(zbx_vmware_service_t *service)
 
 	zbx_vector_vmware_datastore_sort(&data->datastores, vmware_ds_id_compare);
 
+	if (ZBX_VMWARE_TYPE_VCENTER == service->type &&
+			SUCCEED != vmware_service_get_clusters_and_resourcepools(service, easyhandle, &data->datastores,
+			&prop_query_values, &data->clusters, &data->resourcepools, &alarms_data, &data->error))
+	{
+		goto clean;
+	}
+
 	if (SUCCEED != zbx_hashset_reserve(&data->hvs, hvs.values_num))
 	{
 		THIS_SHOULD_NEVER_HAPPEN;
@@ -7893,7 +8659,8 @@ int	zbx_vmware_service_update(zbx_vmware_service_t *service)
 	zbx_vector_vmware_datastore_sort(&data->datastores, vmware_ds_uuid_compare);
 
 	vmware_service_dvswitch_load(easyhandle, &dvs_query_values);
-	vmware_service_props_load(easyhandle, &prop_query_values);
+	vmware_service_props_load(easyhandle, vmware_service_objects[service->type].property_collector,
+			&prop_query_values);
 	zbx_vector_vmware_alarm_sort(&data->alarms, ZBX_DEFAULT_STR_PTR_COMPARE_FUNC);
 
 	if (0 == service->eventlog.req_sz && 0 == evt_pause)
@@ -8189,7 +8956,7 @@ static void	vmware_service_parse_perf_data(zbx_vector_ptr_t *perfdata, xmlDoc *x
 
 	for (i = 0; i < nodeset->nodeNr; i++)
 	{
-		zbx_vmware_perf_data_t 	*data;
+		zbx_vmware_perf_data_t	*data;
 		int			ret = FAIL;
 
 		data = (zbx_vmware_perf_data_t *)zbx_malloc(NULL, sizeof(zbx_vmware_perf_data_t));
@@ -8352,7 +9119,7 @@ static void	vmware_service_retrieve_perf_counters(zbx_vmware_service_t *service,
 				char	st_str[ZBX_XML_DATETIME];
 
 				/* add startTime for entity performance counter request for decrease XML data load */
-				st_raw = zbx_time() - SEC_PER_HOUR;
+				st_raw = time(NULL) - SEC_PER_HOUR;
 				gmtime_r(&st_raw, &st);
 				strftime(st_str, sizeof(st_str), "%Y-%m-%dT%TZ", &st);
 				zbx_snprintf_alloc(&tmp, &tmp_alloc, &tmp_offset, "<ns0:startTime>%s</ns0:startTime>",
@@ -8367,10 +9134,17 @@ static void	vmware_service_retrieve_perf_counters(zbx_vmware_service_t *service,
 
 				counter = (zbx_vmware_perf_counter_t *)entity->counters.values[j];
 
+				if (0 != (counter->state & ZBX_VMWARE_COUNTER_CUSTOM) &&
+						0 == (counter->state & ZBX_VMWARE_COUNTER_ACCEPTABLE))
+				{
+					continue;
+				}
+
 				zbx_snprintf_alloc(&tmp, &tmp_alloc, &tmp_offset,
 						"<ns0:metricId><ns0:counterId>" ZBX_FS_UI64
 						"</ns0:counterId><ns0:instance>%s</ns0:instance></ns0:metricId>",
-						counter->counterid, entity->query_instance);
+						counter->counterid, NULL == counter->query_instance ?
+						entity->query_instance : counter->query_instance);
 
 				counter->state |= ZBX_VMWARE_COUNTER_UPDATING;
 
@@ -8428,6 +9202,213 @@ static void	vmware_service_retrieve_perf_counters(zbx_vmware_service_t *service,
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __func__);
 }
 
+/******************************************************************************
+ *                                                                            *
+ * Purpose: remove unused performance counters                                *
+ *                                                                            *
+ * Parameters: counters - [IN] the list of perf counters                      *
+ *                                                                            *
+ * Return value: SUCCEED - the performance entity is empty (can be deleted)   *
+ *               FAIL    - otherwise                                          *
+ *                                                                            *
+ ******************************************************************************/
+static int	vmware_perf_counters_expired_remove(zbx_vector_ptr_t *counters)
+{
+	int	i;
+	time_t	now = time(NULL);
+
+	for (i = counters->values_num - 1; i >= 0 ; i--)
+	{
+		zbx_vmware_perf_counter_t	*counter = (zbx_vmware_perf_counter_t *)counters->values[i];
+
+		if (0 == (counter->state & ZBX_VMWARE_COUNTER_CUSTOM))
+			continue;
+
+		if (0 == counter->last_used ||
+				(0 != (counter->state & ZBX_VMWARE_COUNTER_NOTSUPPORTED) &&
+				now - SEC_PER_HOUR * 2 < counter->last_used) ||
+				(0 == (counter->state & ZBX_VMWARE_COUNTER_NOTSUPPORTED) &&
+				now - SEC_PER_DAY < counter->last_used))
+		{
+			continue;
+		}
+
+		vmware_perf_counter_shared_free(counter);
+		zbx_vector_ptr_remove(counters, i);
+	}
+
+	return 0 == counters->values_num ? SUCCEED : FAIL;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: update cache with lists of available perf counter for entity      *
+ *                                                                            *
+ * Parameters: service        - [IN] the vmware service                       *
+ *             easyhandle     - [IN] prepared cURL connection handle          *
+ *             type           - [IN] vmware object type (vm, hv etc)          *
+ *             id             - [IN] vmware object id (vm, hv etc)            *
+ *             refresh        - [IN] vmware refresh interval for perf counter *
+ *             begin_time     - [IN] vmware begin time for perf counters list *
+ *             perf_available - [IN/OUT] list of available counter per object *
+ *             perf           - [IN/OUT] the list of perf entities            *
+ *             error          - [OUT] the error message in the case of failure*
+ *                                                                            *
+ * Return value: SUCCEED - the operation has completed successfully           *
+ *               FAIL    - the operation has failed                           *
+ ******************************************************************************/
+static int	vmware_perf_available_update(zbx_vmware_service_t *service, CURL *easyhandle, const char *type,
+		const char *id, const int refresh, const char *begin_time, zbx_vector_perf_available_t *perf_available,
+		zbx_vmware_perf_available_t **perf, char **error)
+{
+#	define ZBX_POST_VMWARE_GET_AVAIL_PERF							\
+		ZBX_POST_VSPHERE_HEADER								\
+		"<ns0:QueryAvailablePerfMetric>"						\
+			"<ns0:_this type=\"PerformanceManager\">%s</ns0:_this>"			\
+			"<ns0:entity type=\"%s\">%s</ns0:entity>"				\
+			"<ns0:beginTime>%s</ns0:beginTime>"					\
+			"%s"									\
+		"</ns0:QueryAvailablePerfMetric>"						\
+		ZBX_POST_VSPHERE_FOOTER
+
+	int			i, ret;
+	char			tmp[MAX_STRING_LEN], interval[MAX_STRING_LEN / 32];
+	xmlDoc			*doc = NULL;
+	zbx_vector_str_t	counters;
+
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s() type:%s id:%s begin_time:%s interval:%d", __func__, type, id,
+			begin_time, refresh);
+
+	zbx_vector_str_create(&counters);
+
+	if (ZBX_VMWARE_PERF_INTERVAL_NONE == refresh)
+		*interval = '\0';
+	else
+		zbx_snprintf(interval, sizeof(interval), "<ns0:intervalId>%d</ns0:intervalId>", refresh);
+
+	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_VMWARE_GET_AVAIL_PERF,
+			vmware_service_objects[service->type].performance_manager, type, id, begin_time, interval);
+
+	if (SUCCEED != (ret = zbx_soap_post(__func__, easyhandle, tmp, &doc, NULL, error)))
+		goto out;
+
+	if (FAIL == zbx_xml_read_values(doc, "/" ZBX_XPATH_LN2("returnval", "counterId"), &counters))
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() empty list for type:%s id:%s interval:%d begin time:%s", __func__,
+				type, id, refresh, begin_time);
+	}
+
+	*perf = (zbx_vmware_perf_available_t *)zbx_malloc(NULL, sizeof(zbx_vmware_perf_available_t));
+	(*perf)->type = zbx_strdup(NULL, type);
+	(*perf)->id = zbx_strdup(NULL, id);
+	zbx_vector_uint16_create(&(*perf)->list);
+
+	for (i = 0; i < counters.values_num; i++)
+	{
+		zbx_vector_uint16_append(&(*perf)->list, (uint16_t)atoi(counters.values[i]));
+	}
+
+	zbx_vector_uint16_sort(&(*perf)->list, vmware_uint16_compare);
+	zbx_vector_uint16_uniq(&(*perf)->list, vmware_uint16_compare);
+	zbx_vector_perf_available_append(perf_available, *perf);
+	zbx_vector_perf_available_sort(perf_available, vmware_perf_available_compare);
+out:
+	zbx_vector_str_clear_ext(&counters, zbx_str_free);
+	zbx_vector_str_destroy(&counters);
+	zbx_xml_free_doc(doc);
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s", __func__, zbx_result_string(ret));
+
+	return ret;
+
+#	undef ZBX_POST_VMWARE_GET_AVAIL_PERF
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: setting flag ZBX_VMWARE_COUNTER_ACCEPTABLE for new perf counters  *
+ *                                                                            *
+ * Parameters: service        - [IN] the vmware service                       *
+ *             easyhandle     - [IN] prepared cURL connection handle          *
+ *             perf_available - [IN/OUT] list of available counter per object *
+ *             entities       - [IN/OUT] the list of perf entities            *
+ *                                                                            *
+ ******************************************************************************/
+static void	vmware_perf_counters_availability_check(zbx_vmware_service_t *service, CURL *easyhandle,
+		zbx_vector_perf_available_t *perf_available, zbx_vector_ptr_t *entities)
+{
+	int	i;
+	char	begin_time[ZBX_XML_DATETIME];
+
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s() entities:%d perf_available:%d", __func__,
+			entities->values_num, perf_available->values_num);
+
+	*begin_time = '\0';
+
+	for (i = 0; i < entities->values_num ; i++)
+	{
+		int				j;
+		zbx_vmware_perf_entity_t	*entity;
+
+		entity = (zbx_vmware_perf_entity_t *)entities->values[i];
+
+		for (j = 0; j < entity->counters.values_num; j++)
+		{
+			int				k;
+			char				*err = NULL;
+			zbx_vmware_perf_counter_t	*counter;
+			zbx_vmware_perf_available_t	*perf, perf_cmp = {.type = entity->type, .id = entity->id};
+
+			counter = (zbx_vmware_perf_counter_t *)entity->counters.values[j];
+
+			if (0 == (counter->state & ZBX_VMWARE_COUNTER_CUSTOM) ||
+					0 != (counter->state & ZBX_VMWARE_COUNTER_ACCEPTABLE))
+			{
+				continue;
+			}
+
+			if ('\0' == *begin_time)
+			{
+				time_t		st_raw;
+				struct	tm	st;
+
+				st_raw = time(NULL) - SEC_PER_HOUR;
+				gmtime_r(&st_raw, &st);
+				strftime(begin_time, sizeof(begin_time), "%Y-%m-%dT%TZ", &st);
+			}
+
+			if (FAIL != (k = zbx_vector_perf_available_bsearch(
+					perf_available, &perf_cmp, vmware_perf_available_compare)))
+			{
+				perf = perf_available->values[k];
+			}
+			else if (FAIL == vmware_perf_available_update(service, easyhandle, entity->type,
+					entity->id, entity->refresh, begin_time, perf_available, &perf, &err))
+			{
+				zabbix_log(LOG_LEVEL_WARNING, "%s() cache update error: %s", __func__, err);
+				zbx_str_free(err);
+				return;
+			}
+
+			if (FAIL == zbx_vector_uint16_bsearch(&perf->list, (uint16_t)counter->counterid,
+					vmware_uint16_compare))
+			{
+				counter->state |= ZBX_VMWARE_COUNTER_NOTSUPPORTED;
+			}
+			else
+			{
+				counter->state |= ZBX_VMWARE_COUNTER_ACCEPTABLE;
+			}
+
+			zabbix_log(LOG_LEVEL_DEBUG, "%s() type:%s id:%s counterid:" ZBX_FS_UI64 " state:%X %s",
+					__func__, entity->type, entity->id, counter->counterid, counter->state,
+					0 == (counter->state & ZBX_VMWARE_COUNTER_ACCEPTABLE) ?
+					"NOTSUPPORTED" : "ACCEPTABLE");
+		}
+	}
+
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __func__);
+}
+
 /******************************************************************************
  *                                                                            *
  * Purpose: updates vmware statistics data                                    *
@@ -8449,6 +9430,7 @@ int	zbx_vmware_service_update_perf(zbx_vmware_service_t *service)
 	zbx_vmware_perf_entity_t	*entity;
 	zbx_hashset_iter_t		iter;
 	zbx_vector_ptr_t		perfdata;
+	zbx_vector_perf_available_t	perf_available;
 	static ZBX_HTTPPAGE		page;	/* 173K */
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() '%s'@'%s'", __func__, service->username, service->url);
@@ -8456,6 +9438,7 @@ int	zbx_vmware_service_update_perf(zbx_vmware_service_t *service)
 	zbx_vector_ptr_create(&entities);
 	zbx_vector_ptr_create(&hist_entities);
 	zbx_vector_ptr_create(&perfdata);
+	zbx_vector_perf_available_create(&perf_available);
 	page.alloc = 0;
 
 	if (NULL == (easyhandle = curl_easy_init()))
@@ -8487,7 +9470,8 @@ int	zbx_vmware_service_update_perf(zbx_vmware_service_t *service)
 	while (NULL != (entity = (zbx_vmware_perf_entity_t *)zbx_hashset_iter_next(&iter)))
 	{
 		/* remove old entities */
-		if (0 != entity->last_seen && entity->last_seen < service->lastcheck)
+		if ((0 != entity->last_seen && entity->last_seen < service->lastcheck) ||
+				SUCCEED == vmware_perf_counters_expired_remove(&entity->counters))
 		{
 			vmware_shared_perf_entity_clean(entity);
 			zbx_hashset_iter_remove(&iter);
@@ -8524,6 +9508,34 @@ int	zbx_vmware_service_update_perf(zbx_vmware_service_t *service)
 
 	zbx_vmware_lock();
 
+	/* checking the availability of custom performance counters */
+	zbx_hashset_iter_reset(&service->entities, &iter);
+	while (NULL != (entity = (zbx_vmware_perf_entity_t *)zbx_hashset_iter_next(&iter)))
+	{
+		for (i = 0; i < entity->counters.values_num; i++)
+		{
+			zbx_vmware_perf_counter_t	*counter;
+
+			counter = (zbx_vmware_perf_counter_t *)entity->counters.values[i];
+
+			if (0 == (counter->state & ZBX_VMWARE_COUNTER_CUSTOM) || 0 != (counter->state &
+					(ZBX_VMWARE_COUNTER_ACCEPTABLE | ZBX_VMWARE_COUNTER_NOTSUPPORTED)))
+			{
+				continue;
+			}
+
+			zbx_vector_ptr_append(&entities, entity);
+			break;
+		}
+	}
+
+	zbx_vmware_unlock();
+
+	vmware_perf_counters_availability_check(service, easyhandle, &perf_available, &entities);
+	zbx_vector_ptr_clear(&entities);
+
+	zbx_vmware_lock();
+
 	zbx_hashset_iter_reset(&service->entities, &iter);
 	while (NULL != (entity = (zbx_vmware_perf_entity_t *)zbx_hashset_iter_next(&iter)))
 	{
@@ -8534,6 +9546,30 @@ int	zbx_vmware_service_update_perf(zbx_vmware_service_t *service)
 			continue;
 		}
 
+		/* pre-check acceptable counters */
+		for (i = 0; i < entity->counters.values_num; i++)
+		{
+			zbx_vmware_perf_counter_t	*counter;
+
+			counter = (zbx_vmware_perf_counter_t *)entity->counters.values[i];
+
+			if (0 != (counter->state & ZBX_VMWARE_COUNTER_CUSTOM) &&
+					0 == (counter->state & ZBX_VMWARE_COUNTER_ACCEPTABLE))
+			{
+				continue;
+			}
+
+			break;
+		}
+
+		if (i == entity->counters.values_num)
+		{
+			zabbix_log(LOG_LEVEL_DEBUG, "skipping performance entity with type:%s id:%s: "
+					"unsupported counters", entity->type, entity->id);
+			continue;
+		}
+
+
 		if (ZBX_VMWARE_PERF_INTERVAL_NONE == entity->refresh)
 			zbx_vector_ptr_append(&hist_entities, entity);
 		else
@@ -8577,6 +9613,9 @@ out:
 
 	zbx_vmware_unlock();
 
+	zbx_vector_perf_available_clear_ext(&perf_available, vmware_perf_available_free);
+	zbx_vector_perf_available_destroy(&perf_available);
+
 	zbx_vector_ptr_clear_ext(&perfdata, (zbx_mem_free_func_t)vmware_free_perfdata);
 	zbx_vector_ptr_destroy(&perfdata);
 
@@ -8770,7 +9809,8 @@ int	zbx_vmware_service_add_perf_counter(zbx_vmware_service_t *service, const cha
 		zbx_uint64_t counterid, const char *instance)
 {
 	zbx_vmware_perf_entity_t	*pentity, entity;
-	int				ret = FAIL;
+	zbx_vmware_perf_counter_t	*counter;
+	int				i, ret = FAIL;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() type:%s id:%s counterid:" ZBX_FS_UI64, __func__, type, id,
 			counterid);
@@ -8789,15 +9829,23 @@ int	zbx_vmware_service_add_perf_counter(zbx_vmware_service_t *service, const cha
 				sizeof(zbx_vmware_perf_entity_t));
 	}
 
-	if (FAIL == zbx_vector_ptr_search(&pentity->counters, &counterid, ZBX_DEFAULT_UINT64_PTR_COMPARE_FUNC))
+	if (FAIL == (i = zbx_vector_ptr_search(&pentity->counters, &counterid, ZBX_DEFAULT_UINT64_PTR_COMPARE_FUNC)))
 	{
-		vmware_counters_add_new(&pentity->counters, counterid);
+		vmware_counters_add_new(&pentity->counters, counterid,
+				ZBX_VMWARE_COUNTER_NEW | ZBX_VMWARE_COUNTER_CUSTOM);
+		counter = (zbx_vmware_perf_counter_t *)pentity->counters.values[pentity->counters.values_num - 1];
 		zbx_vector_ptr_sort(&pentity->counters, ZBX_DEFAULT_UINT64_PTR_COMPARE_FUNC);
 
 		ret = SUCCEED;
 	}
+	else
+		counter = (zbx_vmware_perf_counter_t *)pentity->counters.values[i];
 
-	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s", __func__, zbx_result_string(ret));
+	if (*ZBX_VMWARE_PERF_QUERY_ALL != *pentity->query_instance)
+		counter->query_instance = vmware_shared_strdup(instance);
+
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s counter state:%X", __func__, zbx_result_string(ret),
+			counter->state);
 
 	return ret;
 }
